#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
import urllib

# Lyrics search engine for http://www.lyricsmania.com/
searcher_title = "lyricsmania.com"
searcher_url = "http://www.lyricsmania.com/"

def get_lyrics(title, artist, list_bad=False):
    url = "http://www.lyricsmania.com/searchnew.php?k=" + urllib.quote(title + " " + artist) + "&x=0&y=0"

    data = urllib.urlopen(url).read()

    if data.find("<br><br>\n\t\t\n\t\t\t<h1><a href=") == -1:
        return [False, url]

    init = data.find("<br><br>\n\t\t\n\t\t\t<h1><a href=\"/")
    data = data[init + len("<br><br>\n\t\t\n\t\t\t<h1><a href=\"/"):data.find("</a></h1><br>\n\n<div></div>", init)]
    results = data.split("</a></h1><br>\n\t\t\n\t\t\t<h1><a href=\"/")
    good_result = 0
    parsed_results = []
    for i in results:
        name = i[i.find("\">") + 2:]
        link = i[:i.find("\" title=\"")]
        if name.find(" - ") != -1:
            parsed_results.append([name, "http://www.lyricsmania.com/" + link])
            if name.lower() == artist.lower() + " - " + title.lower():
                good_result = 1
                break;
    if not good_result:
        if list_bad:
            return [parsed_results, url]
    url = "http://www.lyricsmania.com/" + link
    return [get_lyrics_from_url(url), url]

def get_lyrics_from_url(url):
    data = urllib.urlopen(url).read()
    init_string = "<div id='songlyrics_h' class='dn'>\n"
    end_string = '</div>\n<script type="text/javascript">'
    init = data.find(init_string)
    html = data[init + len(init_string):data.find(end_string, init)]
    lyrics = html.replace(" <br />", "").replace("<br />", "")
    return lyrics

